---
title: Preview Surveys with Runtime Variables
product: Survey Creator
description: Use variable presets to test survey logic that depends on application data. This JavaScript demo shows how to switch customer profiles and edit variable values in Survey Creator's Preview tab.
framework: Angular
source: https://surveyjs.io/survey-creator/examples/test-runtime-dependent-survey-logic/angular
index: https://surveyjs.io/survey-creator/examples/overview.md
---

# Preview Surveys with Runtime Variables (Angular)

Survey logic can depend on application data, such as a customer's plan or role. To test this logic, you can save sample values as named sets called **variable presets**. Use the selector at the bottom of Preview to switch between three customer profiles: "Basic member", "Premium member", and "Premium administrator". Click **Manage presets** to view, edit, add, or delete presets.

To configure presets, set the [`variablePresets`](/survey-creator/documentation/api-reference/icreatoroptions#variablePresets) property to an object with these properties:

- `definition`\
A survey JSON definition whose questions describe the variables. Question names identify variables, while question types, choices, and validators configure the preset editor. In this demo, a Dropdown question defines `customerTier` and a Yes/No question defines `isAccountAdmin`.
- `presets`\
An array of named variable presets. Each entry contains a unique `name`, an optional `description`, and a `variables` object that maps variable names to values.

Variables in survey expressions are referenced using curly brackets, just as question names. This demo uses `"enableIf": "{customerTier} = 'premium'"` to enable priority support and `"visibleIf": "{isAccountAdmin} = true"` to show the billing question. The variable definition also makes these variables available in visual condition editors.

Preset edits are kept in memory for the browser session. To save them, handle the [`onVariablePresetsChanged`](/survey-creator/documentation/api-reference/survey-creator#onVariablePresetsChanged) event and persist `options.variablePresets` when `options.reason === "edit"`.

Refer to the Code tab for the complete survey and variable preset definitions.

## Files

### `src/app/components/creator.component.css`

```css
/* You can define custom CSS rules here */
```

### `src/app/components/creator.component.html`

```html
<div style="position: fixed; top: 0; bottom: 0; right: 0; left: 0;">
    <survey-creator [model]="model"></survey-creator>
</div>
```

### `src/app/components/survey_json.js`

```js
export const surveyJSON = {
  "title": "Support Request",
  "description": "Tell us how we can help you with your account.",
  "pages": [
    {
      "name": "supportRequest",
      "elements": [
        {
          "type": "comment",
          "name": "requestDetails",
          "title": "How can we help?",
          "isRequired": true
        },
        {
          "type": "boolean",
          "name": "prioritySupport",
          "title": "Would you like priority support?",
          "description": "Priority support is available on the Premium plan.",
          "enableIf": "{customerTier} = 'premium'"
        },
        {
          "type": "comment",
          "name": "billingDetails",
          "title": "Do you need help with billing?",
          "description": "Account administrators can include billing questions in their request.",
          "visibleIf": "{isAccountAdmin} = true"
        }
      ]
    }
  ]
};
```

### `src/app/components/variable_presets.js`

```js
export const variablePresets = {
  "definition": {
    "elements": [
      {
        "type": "dropdown",
        "name": "customerTier",
        "title": "Customer plan",
        "isRequired": true,
        "choices": [
          { "value": "basic", "text": "Basic" },
          { "value": "premium", "text": "Premium" }
        ]
      },
      {
        "type": "boolean",
        "name": "isAccountAdmin",
        "title": "Account administrator",
        "isRequired": true
      }
    ]
  },
  "presets": [
    {
      "name": "Basic member",
      "description": "A Basic customer without access to account billing.",
      "variables": {
        "customerTier": "basic",
        "isAccountAdmin": false
      }
    },
    {
      "name": "Premium member",
      "description": "A Premium customer with priority support, but no access to account billing.",
      "variables": {
        "customerTier": "premium",
        "isAccountAdmin": false
      }
    },
    {
      "name": "Premium administrator",
      "description": "A Premium customer with priority support and access to account billing.",
      "variables": {
        "customerTier": "premium",
        "isAccountAdmin": true
      }
    }
  ]
};
```

### `src/app/components/creator.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { SurveyCreatorModel } from "survey-creator-core";
import "survey-core/survey.i18n";
import "survey-creator-core/survey-creator-core.i18n";
import { surveyJSON } from "./survey_json";
import { variablePresets } from "./variable_presets";

import "survey-core/survey-core.css";
import "survey-creator-core/survey-creator-core.css";

import SurveyTheme from "survey-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SurveyTheme); // Add predefined Survey Creator UI themes

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey-creator",
    templateUrl: "./creator.component.html",
    styleUrls: ["./creator.component.css"]
})
export class SurveyCreatorComponent implements OnInit {
    model: SurveyCreatorModel;
    ngOnInit() {
        const creator = new SurveyCreatorModel({ variablePresets });
        creator.JSON = surveyJSON;
        creator.activeTab = "preview";
        
        this.model = creator;
    }
}
```

### `src/app/app.component.html`

```html
<component-survey-creator></component-survey-creator>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html"
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";
import { AppComponent } from "./app.component";
import { SurveyCreatorModule } from "survey-creator-angular";
import { SurveyCreatorComponent } from "./components/creator.component";

@NgModule({
    declarations: [AppComponent, SurveyCreatorComponent],
    imports: [BrowserModule, SurveyCreatorModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<link href="https://fonts.googleapis.com/css?family=Open%20Sans:400,600&display=swap" rel="stylesheet">
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
/* You can add global styles to this file and import other style files */
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css"  ],
      "scripts": [  ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-angular-ui": "latest",
    "survey-creator-core": "latest",
    "survey-core": "latest",
    "survey-creator-angular": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular-devkit/build-angular": "~13.0.0",
    "@angular/cli": "~13.0.0",
    "@types/jasmine": "3.6.3",
    "@types/jasminewd2": "2.0.8",
    "@types/node": "14.14.28",
    "codelyzer": "6.0.1",
    "jasmine-core": "3.6.0",
    "jasmine-spec-reporter": "6.0.0",
    "karma": "6.1.1",
    "karma-chrome-launcher": "3.1.0",
    "karma-coverage-istanbul-reporter": "3.0.3",
    "karma-jasmine": "4.0.1",
    "karma-jasmine-html-reporter": "1.5.4",
    "protractor": "7.0.0",
    "ts-node": "9.1.1",
    "tslint": "~6.1.3",
    "typescript": "4.1.5"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/survey-creator/examples/test-runtime-dependent-survey-logic/reactjs.md)
- [Vue 3](https://surveyjs.io/survey-creator/examples/test-runtime-dependent-survey-logic/vue3js.md)
- [jQuery](https://surveyjs.io/survey-creator/examples/test-runtime-dependent-survey-logic/jquery.md)
- [Vanilla JS](https://surveyjs.io/survey-creator/examples/test-runtime-dependent-survey-logic/vanillajs.md)


---
title: Preview Surveys with Runtime Variables
product: Survey Creator
description: Use variable presets to test survey logic that depends on application data. This JavaScript demo shows how to switch customer profiles and edit variable values in Survey Creator's Preview tab.
framework: React
source: https://surveyjs.io/survey-creator/examples/test-runtime-dependent-survey-logic/reactjs
index: https://surveyjs.io/survey-creator/examples/overview.md
---

# Preview Surveys with Runtime Variables (React)

Survey logic can depend on application data, such as a customer's plan or role. To test this logic, you can save sample values as named sets called **variable presets**. Use the selector at the bottom of Preview to switch between three customer profiles: "Basic member", "Premium member", and "Premium administrator". Click **Manage presets** to view, edit, add, or delete presets.

To configure presets, set the [`variablePresets`](/survey-creator/documentation/api-reference/icreatoroptions#variablePresets) property to an object with these properties:

- `definition`\
A survey JSON definition whose questions describe the variables. Question names identify variables, while question types, choices, and validators configure the preset editor. In this demo, a Dropdown question defines `customerTier` and a Yes/No question defines `isAccountAdmin`.
- `presets`\
An array of named variable presets. Each entry contains a unique `name`, an optional `description`, and a `variables` object that maps variable names to values.

Variables in survey expressions are referenced using curly brackets, just as question names. This demo uses `"enableIf": "{customerTier} = 'premium'"` to enable priority support and `"visibleIf": "{isAccountAdmin} = true"` to show the billing question. The variable definition also makes these variables available in visual condition editors.

Preset edits are kept in memory for the browser session. To save them, handle the [`onVariablePresetsChanged`](/survey-creator/documentation/api-reference/survey-creator#onVariablePresetsChanged) event and persist `options.variablePresets` when `options.reason === "edit"`.

Refer to the Code tab for the complete survey and variable preset definitions.

## Files

### `public/index.html`

```html
<link href="https://fonts.googleapis.com/css?family=Open%20Sans:400,600&display=swap" rel="stylesheet">
<!-- Uncomment the following lines to enable Ace Editor in the JSON Editor tab -->
<!-- 
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ace.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ext-searchbox.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/theme-clouds_midnight.js"></script>
-->

<div id="surveyCreatorContainer" style="position: absolute; height: 100%; width: 100%"></div>
```

### `src/survey_json.js`

```js
export const surveyJSON = {
  "title": "Support Request",
  "description": "Tell us how we can help you with your account.",
  "pages": [
    {
      "name": "supportRequest",
      "elements": [
        {
          "type": "comment",
          "name": "requestDetails",
          "title": "How can we help?",
          "isRequired": true
        },
        {
          "type": "boolean",
          "name": "prioritySupport",
          "title": "Would you like priority support?",
          "description": "Priority support is available on the Premium plan.",
          "enableIf": "{customerTier} = 'premium'"
        },
        {
          "type": "comment",
          "name": "billingDetails",
          "title": "Do you need help with billing?",
          "description": "Account administrators can include billing questions in their request.",
          "visibleIf": "{isAccountAdmin} = true"
        }
      ]
    }
  ]
};
```

### `src/variable_presets.js`

```js
export const variablePresets = {
  "definition": {
    "elements": [
      {
        "type": "dropdown",
        "name": "customerTier",
        "title": "Customer plan",
        "isRequired": true,
        "choices": [
          { "value": "basic", "text": "Basic" },
          { "value": "premium", "text": "Premium" }
        ]
      },
      {
        "type": "boolean",
        "name": "isAccountAdmin",
        "title": "Account administrator",
        "isRequired": true
      }
    ]
  },
  "presets": [
    {
      "name": "Basic member",
      "description": "A Basic customer without access to account billing.",
      "variables": {
        "customerTier": "basic",
        "isAccountAdmin": false
      }
    },
    {
      "name": "Premium member",
      "description": "A Premium customer with priority support, but no access to account billing.",
      "variables": {
        "customerTier": "premium",
        "isAccountAdmin": false
      }
    },
    {
      "name": "Premium administrator",
      "description": "A Premium customer with priority support and access to account billing.",
      "variables": {
        "customerTier": "premium",
        "isAccountAdmin": true
      }
    }
  ]
};
```

### `src/SurveyCreatorComponent.jsx`

```js
import React from "react";
import { SurveyCreator, SurveyCreatorComponent } from "survey-creator-react";
import "survey-core/survey.i18n";
import "survey-creator-core/survey-creator-core.i18n";
import { surveyJSON } from "./survey_json";
import { variablePresets } from "./variable_presets";

import "survey-core/survey-core.css";
import "survey-creator-core/survey-creator-core.css";
import "./index.css";

import SurveyTheme from "survey-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SurveyTheme); // Add predefined Survey Creator UI themes

function SurveyCreatorRenderComponent() {
    const creator = new SurveyCreator({ variablePresets });
    creator.JSON = surveyJSON;
    creator.activeTab = "preview";
    
    return (<SurveyCreatorComponent creator={creator} />);
}

export default SurveyCreatorRenderComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyCreatorRenderComponent from "./SurveyCreatorComponent";

const root = createRoot(document.getElementById("surveyCreatorContainer"));
root.render(<SurveyCreatorRenderComponent />);
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest",
    "survey-creator-core": "latest",
    "survey-creator-react": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/survey-creator/examples/test-runtime-dependent-survey-logic/angular.md)
- [Vue 3](https://surveyjs.io/survey-creator/examples/test-runtime-dependent-survey-logic/vue3js.md)
- [jQuery](https://surveyjs.io/survey-creator/examples/test-runtime-dependent-survey-logic/jquery.md)
- [Vanilla JS](https://surveyjs.io/survey-creator/examples/test-runtime-dependent-survey-logic/vanillajs.md)
